/*** feature.js ***************************************************************
*** Athur:        Henning Kristiansen                                       ***
*** Program:      Map Editor                                                ***
*** Date:         2003-05-11                                                ***
*** Project:      OneMap.Submission.GUI                                     ***
***                                                                         ***
*** Description:                                                            ***
***   This file contains all of the function regared the feature menu.      ***
***   It does not meen that it a stand-alone module because this is         ***
***   depended on variables from other files in this prosject. And is also  ***
***   depended on the way the SVG file is structured and has all the ID's   ***
***   that this looks for. And that noone of these ID's is being used more  ***
***   than that one time                                                    ***
***                                                                         ***
***   Every function goes throught the functions.js file except the once    ***
***   that is onclick events from the SVG                                   ***
***                                                                         ***
*** THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED        ***
*** WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF    ***
*** MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN ***
*** NO EVENT SHALL THE ONE MAP PROJECT OR ITS CONTRIBUTORS BE LIABLE FOR    ***
*** ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL  ***
*** DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS ***
*** OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)   ***
*** HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,     ***
*** STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING   ***
*** IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE      ***
*** POSSIBILITY OF SUCH DAMAGE.                                             ***
******************************************************************************/

/**
	All the variables needed within the feature
**/
var feature, featureMenu;
var featureMenuX = 0, featureMenuY = 0;
var featureMenuResetX, featureMenuResetY;
var dragFeatureMenu = false;
var featureProperties, featureProertiesName, featureProertiesType, featureProertiesValue;
var feautreWindowDrag = false;
var feautreWindowDraging = "";
var featureScrollbarWidth, featureScrollbarWidthHigh, featureScrollbarX = 16, featureScrollbarY = 16;
var featureVerticalScrollbar, featureHorizontalScrollbar;
var dragfeatureVerticalScrollbar = false, dragfeatureHorizontalScrollbar = false;
var feautreInfo,feautreInfoGeo;
var featureMenuShow;
var featurePropertiesViewX;

/***initFeature()**************************************************************
*** This initiates the feature menu                                         ***
******************************************************************************/
function initFeature() {
	feature = svgdoc.getElementById('feature');
	featureMenu = svgdoc.getElementById('featureMenu');

	featureProperties = svgdoc.getElementById('featureProperties');
	featureProertiesName = svgdoc.getElementById('featureProertiesName');
	featureProertiesType = svgdoc.getElementById('featureProertiesType');
	featureProertiesValue = svgdoc.getElementById('featureProertiesValue');

	featureVerticalScrollbar = svgdoc.getElementById("featureScrollbarVerDrag");
	featureHorizontalScrollbar = svgdoc.getElementById("featureScrollbarHorDrag");
	featureMenuShow = svgdoc.getElementById("featureMenuShow");	

	removeAllTextFromSVG(featureProertiesName);
	removeAllTextFromSVG(featureProertiesType);
	removeAllTextFromSVG(featureProertiesValue);
	
	removeAllTextFromSVG(feature);

	setFeatureMenu();
}
/***moveFeatureMenu()**********************************************************
*** A function to move the menu. The parameter shows how much it will move  ***
*** It also stores what the x and y value for the menu at all time. And if  ***
*** the windowscale is wider then the 800/500 scale it will add to the X so ***
*** much that it would look like it goes up to the right corner.            ***
***                                                                         ***
*** View the documentation for more information about this                  ***
******************************************************************************/
function moveFeatureMenu(moveX, moveY) {
	featureMenuX += moveX;
	featureMenuY += moveY;

	if (windowscaleway) {
		var newWidth = (130 * windowscale);
		var newXAdd = (130 * windowscaleWidth);
		newXAdd -= newWidth;
	}
	else
		var newXAdd = 0;

	featureMenu.setAttribute('x',featureMenuX+newXAdd + "");
	featureMenu.setAttribute('y',featureMenuY + "");
}
/***setFeatureMenu()***********************************************************
*** This finds out what the x and y value is from the start and stores that ***
*** in case it will ever be reset. After that it will scale to fit the      ***
*** current view that the SVG window is in                                  ***
******************************************************************************/
function setFeatureMenu() {
	featureMenuResetX = parseInt(featureMenu.getAttribute('x'));
	featureMenuResetY = parseInt(featureMenu.getAttribute('y'));	
	featureMenuX = featureMenuResetX;
	featureMenuY = featureMenuResetY;
	
	scaleFeatureMenu(false);
}

/***resetFeatureMenu()*********************************************************
*** reset the menu to it's orignial view                                    ***
******************************************************************************/
function resetFeatureMenu() {
	featureMenu.setAttribute('x',(featureMenuResetX * ratioWidth) + "");
	featureMenu.setAttribute('y',(featureMenuResetY * ratioHeight) + "");
}
/***scaleFeatureMenu()*********************************************************
*** This scales the menu so it will be put at the right place with the      ***
*** right height and width                                                  ***
******************************************************************************/
function scaleFeatureMenu(move) {	
	var newWidth = (250 * windowscale);
	var newHeight = (250 * windowscale);

	featureMenu.setAttribute('width', newWidth + "");
	featureMenu.setAttribute('height', newHeight + "");
	
	if (move) moveFeatureMenu(((featureMenuX*ratioWidth) - featureMenuX), ((featureMenuY*ratioHeight) - featureMenuY));
}
/***showFeatureMenu()**********************************************************
*** This function either shows or hides the feature menu depening on the    ***
*** show parameter.                                                         ***
******************************************************************************/
function showFeatureMenu(show) {
	featureMenuShow.setAttribute('visibility',show);
	if (show == "visible") {
		featureVerticalVisibility();
		featureHorizontalVisibility();
	}
}
/***featureOver()**************************************************************
*** This shows the dragging button on the propertistitle when the mouse is  ***
*** over it. But only when you are not dragging it                          ***
******************************************************************************/
function featureOver(evt) {
	if (!feautreWindowDrag) evt.getTarget().setAttribute("opacity", 0.5);
}
/***featureOver()**************************************************************
*** This hides the dragging button on the propertistitle when the mouse is  ***
*** not over it anymore. But only when you are not dragging it              ***
******************************************************************************/
function featureOut(evt) {
	if (!feautreWindowDrag) evt.getTarget().setAttribute("opacity", 0);	
}
/***dragPropertiesTitleWindow()************************************************
*** This drags the properties window                                        ***
******************************************************************************/
function dragPropertiesTitleWindow(moveX) {
	var temp;
	
	/**
		Since this function goes for all the three dragins this finds
		what the acctual target is
	**/
	var target = svgdoc.getElementById(feautreWindowDraging);
	
	/**
		Gets the new x value
	**/
	var newX = parseInt(target.getAttribute('x'))+moveX;
	
	/**
		Finds out what the minimum value can be so it want drag over any of
		the other properties
	**/
	var minX = 8;
	if (feautreWindowDraging == "Type") {
		temp = svgdoc.getElementById("Name");
		minX = parseInt(temp.getAttribute('x'))+10;		
	}
	
	if (feautreWindowDraging == "Value") {
		temp = svgdoc.getElementById("Type");
		minX = parseInt(temp.getAttribute('x'))+10;		
	}
	/**
		If it trys to drag over the minmum it will simply just stop
	**/
	if (newX < minX) {
		feautreWindowDrag = false;		
		target.setAttribute("opacity", 0);
		return;
	}
	/**
		Finds out what the highest value is
	**/	
	temp = svgdoc.getElementById("Value");
	featureScrollbarWidthHigh = parseInt(temp.getAttribute('x')) + 2;
	/**
		Moves the draging
	**/
	target.setAttribute('x',newX + "")
	/**
		The next one here moves everything else
	**/
	temp = svgdoc.getElementById("feautreWindow" + feautreWindowDraging);
	var newWidth = parseInt(temp.getAttribute('width')) + moveX;
	temp.setAttribute('width', newWidth + "");
	temp.setAttribute('viewBox', "0 0 " + newWidth + " 167");
	temp = svgdoc.getElementById("featureWindowBackGround" + feautreWindowDraging);
	temp.setAttribute('width', newWidth + "");

	temp = svgdoc.getElementById("featureWindowWhiteStroke" + feautreWindowDraging);
	temp.setAttribute('width', newWidth + "");

	temp = svgdoc.getElementById("feautreWindowProperties" + feautreWindowDraging);
	temp.setAttribute('width', newWidth + "");
	temp.setAttribute('viewBox', "0 0 " + newWidth + " 147");

	temp = svgdoc.getElementById("feautreWindowPropertiesStroke" + feautreWindowDraging);
	temp.setAttribute('width', newWidth + "");

	/**
		If we are dragging the name window it has to make the
		type window follow after
	**/
	if (feautreWindowDraging == "Name") {
		temp = svgdoc.getElementById("feautreWindowType");
		temp.setAttribute('x', parseInt(temp.getAttribute('x'))+moveX);
		temp = svgdoc.getElementById("Type");
		temp.setAttribute('x', parseInt(temp.getAttribute('x'))+moveX);		
	}
	/**
		If we are dragging the name or type window it has to make the
		value window follow after
	**/
	if ((feautreWindowDraging == "Name") || (feautreWindowDraging == "Type")) {
		temp = svgdoc.getElementById("feautreWindowValue");
		temp.setAttribute('x', parseInt(temp.getAttribute('x'))+moveX);		
		temp = svgdoc.getElementById("Value");
		featureScrollbarWidthHigh += moveX;
		temp.setAttribute('x', (featureScrollbarWidthHigh-2) + "");
	}

	temp = svgdoc.getElementById("PropertiesTopic");
	temp.setAttribute('width', (featureScrollbarWidthHigh+200) + "");
	
	featureHorizontalVisibility();

}
/***startChangeFeature()*******************************************************
*** To change the value of the feature the user has to doubleclick the      ***
*** feature it wants to change. Since there are no doubleclick events you   ***
*** have to simulate this. And that is what this this function does. If it  ***
*** detects two clicks within 250ms it will start the changeFeature         ***
******************************************************************************/
function startChangeFeature(evt,what) {
	mouseClickCount++;
	mouseClickTarget = evt.getTarget();
	clickEVT = evt;
	if (mouseClickCount == 1) 
		var interval = window.setTimeout("removeClickInfo()",250);
	else 
		changeFeature(evt,what);
}
/***removeFeatureInfoMenu()****************************************************
*** This removes the featureinfo menu and resets all it set                 ***
******************************************************************************/
function removeFeatureInfoMenu() {
	feautreInfoGeo.removeAttribute("stroke");
	feautreInfoGeo.removeAttribute("stroke-width");
	feautreInfoGeo = null;
	showFeatureMenu("hidden");
	featureVerticalScrollbar.setAttribute("visibility", "hidden");
	featureHorizontalScrollbar.setAttribute("visibility", "hidden");
	
}
/***setHighlightedFutureStrokeWidth()******************************************
*** Sets the strokewidth to be as wide as the window is                     ***
******************************************************************************/
function setHighlightedFutureStrokeWidth() {	
	if (feautreInfoGeo == null)
		return;
	var sw = (0.8 - (0.4 * windowscale)) + "%";
	feautreInfoGeo.setAttribute("stroke-width", sw);
}
/***startClickFeature()********************************************************
*** cheks if it is inside the feature that is been clicked                  ***
******************************************************************************/
function startClickFeature(evt) {
	var target = evt.getTarget().getAttribute('id');
	if (target == 'featureBackground')
		dragFeatureMenu = true;			
	if ((target == 'Name') || (target == 'Type') || (target == 'Value')) {
		feautreWindowDrag = true;
		feautreWindowDraging = target;
	}
	if (target == 'featureScrollbarVerDrag')		
		dragfeatureVerticalScrollbar = true;
	if (target == 'featureScrollbarHorDrag')		
		dragfeatureHorizontalScrollbar = true;	
}
/***stopClickFeature()********************************************************
*** cheks if it is inside the feature that has stopped clicked.            ***
*****************************************************************************/
function stopClickFeature(evt) {	
	var target = evt.getTarget().getAttribute('id')
	if (target == 'featureBackground')
		if (dragFeatureMenu) {
			dragFeatureMenu = false;
			return;
		}
	if ((target == 'Name') || (target == 'Type') || (target == 'Value') || (target == 'PropertiesTopic')) 
		if (feautreWindowDrag) {
			if (target == 'PropertiesTopic') {
				var remove = svgdoc.getElementById(feautreWindowDraging);
				remove.setAttribute("opacity", 0);					
			}
			feautreWindowDrag = false;
			return;
		}
	if (target == 'featureScrollbarVerDrag')		
		if (dragfeatureVerticalScrollbar) {
			dragfeatureVerticalScrollbar = false;
			return;
		}
	if (target == 'featureScrollbarHorDrag')
		if (dragfeatureHorizontalScrollbar) {
			dragfeatureHorizontalScrollbar = false;
			return;
		}
}
/***checkMouseFeature()********************************************************
*** if the menu is being dragged or the featurewindow is beeing dragged     ***
*** this is the function that moves this                                    ***
******************************************************************************/
function checkMouseFeature(evt) {
	if (dragfeatureVerticalScrollbar) {
		var target = evt.getTarget().getAttribute('id');
		if ((target != 'featureScrollbarVerDrag') && (target != 'featureScrollbarVerBack'))
			dragfeatureVerticalScrollbar = false;
		else {
			var now = parseInt(currentClientY/windowscale);
			var last = parseInt(lastClientY/windowscale);
			if ((now - last) != 0) 
				moveFeautreVerticalScrollBar((now-last),false);			
		}
	}
	if (dragfeatureHorizontalScrollbar) {
		var target = evt.getTarget().getAttribute('id');
		if ((target != 'featureScrollbarHorDrag') && (target != 'featureScrollbarHorBack'))
			dragfeatureHorizontalScrollbar = false;
		else {
			var now = parseInt(currentClientX/windowscale);
			var last = parseInt(lastClientX/windowscale);
			if ((now - last) != 0) 
				moveFeautreHorizontalScrollBar((now-last),false);			
		}
	}
	if (dragFeatureMenu) 
		moveFeatureMenu((currentClientX-lastClientX),(currentClientY-lastClientY));
	
	if (feautreWindowDrag) {
		var target = evt.getTarget().getAttribute('id');
		if ((target == 'Name') || (target == 'Type') || (target == 'Value') || (target == 'PropertiesTopic')) {
			var now = parseInt(currentClientX/windowscale);
			var last = parseInt(lastClientX/windowscale);
			dragPropertiesTitleWindow((now-last));
			
		}
		else {
			target = svgdoc.getElementById(feautreWindowDraging);
			target.setAttribute("opacity", 0);
			feautreWindowDrag = false;
		}
		
	}
}

/***getFeautreInfo()***********************************************************
*** This is the start of opening the featureinfo.                           ***
******************************************************************************/
function getFeautreInfo(evt) {
	/**
		If the user clicks on a featurewindow while the window is up it removes 
		the stroke for the last selected one
	**/
	if (feautreInfoGeo != null) {
		feautreInfoGeo.removeAttribute("stroke");
		feautreInfoGeo.removeAttribute("stroke-width");
	}
	/**
		Finds the line that has been clicked. If this is null i returns. 
		(this is not suppose to happend).
	**/
	feautreInfoGeo = svgdoc.getElementById(evt.parentNode.getAttribute("source"));
	if (feautreInfoGeo == null)
		return;
	/**
		Sets the stroke of the new one so the user can see the whole line
	**/
	var temp;
	feautreInfoGeo.setAttribute("stroke", "#9FB086");
	setHighlightedFutureStrokeWidth();
	/**
		Sets the stroke of the new one so the user can see the whole line
	**/
	feautreinfo = svgdoc.getElementById(feautreInfoGeo.getAttribute("feature"));
	/**
		Sets the featureinfo title
	**/
	var temp = svgdoc.getElementById("featureTitle");
	temp.getFirstChild().setData(feautreinfo.getAttribute('type') + ": " + feautreinfo.getAttribute('fid'));
	/**
		Show the proprties for the feature
	**/	
	setProperties();
	/**
		Shows the feature window
	**/	
	showFeatureMenu("visible");
}
/***setProperties()************************************************************
*** Sets and resets the proprties                                           ***
******************************************************************************/
function setProperties() {
	/**
		removes all of the info that allready was there
	**/
	removeAllChilds(featureProertiesName);
	removeAllChilds(featureProertiesType);
	removeAllChilds(featureProertiesValue);	
	/**
		Goes through every properties of the selected feature and shows it
	**/	
	var kid = feautreinfo.childNodes;
	for(var i=0;i<kid.length;i++) {
		var nameElement = svgdoc.createElement("g");
		var newText = svgdoc.createElement("text");
		newText.appendChild(svgdoc.createTextNode (kid.item(i).getAttribute('name')));
		newText.setAttribute("x",5);
		newText.setAttribute("y",((i*20)+13));		
		nameElement.appendChild(newText);

		var newRect = svgdoc.createElement("rect");
		newRect.setAttribute("x",0);
		newRect.setAttribute("y",(i*20));
		newRect.setAttribute("width",800);
		newRect.setAttribute('fill',"white");
		newRect.setAttribute('propertyid',kid.item(i).getAttribute('id'));
		newRect.setAttribute("onclick","startChangeFeature( evt, 'name' )");
		newRect.setAttribute("onmouseover","featurePropertyOver( evt, 'red' )");
		newRect.setAttribute("onmouseout","featurePropertyOver( evt, 'black' )");
		newRect.setAttribute("opacity",0);
		newRect.setAttribute("height",20);
		nameElement.appendChild(newRect);

		featureProertiesName.appendChild(nameElement);
		
		var typeElement = nameElement.cloneNode(true);
		typeElement.childNodes.item(0).getFirstChild().setData(kid.item(i).getAttribute('type'));	
		typeElement.childNodes.item(1).setAttribute("onclick","startChangeFeature( evt, 'type' )");
		featureProertiesType.appendChild(typeElement);
		
		var valueElement = nameElement.cloneNode(true);
		valueElement.childNodes.item(0).getFirstChild().setData(kid.item(i).getAttribute('value'));
		valueElement.childNodes.item(1).setAttribute("onclick","startChangeFeature( evt, 'value' )");
		featureProertiesValue.appendChild(valueElement);

	}
	featureScrollbarHeightHigh = (i*20);	
}
/***changeFeature()************************************************************
*** This is the function that will change the feature                       ***
******************************************************************************/
function changeFeature(evt,what) {
	/**
		Gets the old data
	**/
	var oldData = evt.getTarget().parentNode.childNodes.item(0).getFirstChild().getData();
	/**
		Sets the new data by opening a imputwindow
	**/
	var newData = prompt("Insert new data",oldData);
	/**
		if there is no change. Or the user has pushed the cancel button it will just
		return. There is *no more* checks then this. It does not check if the input
		valids or nothing like that.
	**/
	if ((newData == null) || (newData == "") || (newData == oldData))
		return;
	/**
		Sets the new data
	**/
	evt.getTarget().parentNode.childNodes.item(0).getFirstChild().setData(newData);	
	/**
		Add the change to the history
	**/
	addPropertyChangeToHistory(newData,oldData,evt.getTarget(),feautreinfo,what);
}
/***featureHorizontalVisibility()**********************************************
*** Finds out if it needs to have a horizantal scrollbar or not. If it does ***
*** it will place it in the right position                                  ***
******************************************************************************/
function featureHorizontalVisibility() {
	if (featureScrollbarWidthHigh > 214) {
		featureHorizontalScrollbar.setAttribute("visibility", "visible");
		
		featureScrollbarWidth = 182 * (214/featureScrollbarWidthHigh);
		featureHorizontalScrollbar.setAttribute("width", featureScrollbarWidth);

		if (featureScrollbarX > (198-featureScrollbarWidth))
			featureScrollbarX = (198-featureScrollbarWidth);
		if (featureScrollbarX < 16)
			featureScrollbarX = 16;
		
		featureHorizontalScrollbar.setAttribute('x',featureScrollbarX + "");
		featurePropertiesViewX = -(214/featureScrollbarWidth) * (featureScrollbarX-16);
		var newtransform = "translate(" + parseInt(featurePropertiesViewX) + ",0)";	
		featureProperties.setAttribute('transform',newtransform);
	}
	else
		featureHorizontalScrollbar.setAttribute("visibility", "hidden");

}
/***featureVerticalVisibility()************************************************
*** Finds out if it needs to have a vertical scrollbar or not. If it does   ***
*** it will place it in the right position                                  ***
******************************************************************************/
function featureVerticalVisibility() {
	if (featureScrollbarHeightHigh > 147) {
		featureVerticalScrollbar.setAttribute("visibility", "visible");
		
		featureScrollbarHeight = 135 * (147/featureScrollbarHeightHigh);
		featureVerticalScrollbar.setAttribute("height", featureScrollbarHeight + "");

		if (featureScrollbarY > (151-featureScrollbarHeight))
			featureScrollbarY = (151-featureScrollbarHeight);
		if (featureScrollbarY < 16)
			featureScrollbarY = 16;
		featureVerticalScrollbar.setAttribute('y',featureScrollbarY + "");
		var newtransform = "translate(0,0)";
		//var temp = svgdoc.getElementById('feautreWindowPropertieName');
		featureProertiesName.setAttribute('transform',newtransform);
		featureProertiesType.setAttribute('transform',newtransform);
		featureProertiesValue.setAttribute('transform',newtransform);
		featureScrollbarY = 16;
		featureVerticalScrollbar.setAttribute('y',featureScrollbarY + "");
	}
	else
		featureVerticalScrollbar.setAttribute("visibility", "hidden");

}
/***featurePropertyOver()******************************************************
*** Changes the color of the text                                           ***
******************************************************************************/
function featurePropertyOver(evt,color) {	
	evt.getTarget().parentNode.childNodes.item(0).setAttribute('fill', color);
}
/***goToFeatureVerticalScrollPosition()****************************************
*** This is if the user clicks on the vertical scollbar back this will find ***
*** out on what side of the scrollbar and go up or down                     ***
******************************************************************************/
function goToFeatureVerticalScrollPosition(evt) {
	if (parseInt((currentClientY - featureMenuY - 57-16)/windowscale) > (featureScrollbarY))
		moveFeautreVerticalScrollBar(50,true);
	else
		moveFeautreVerticalScrollBar(-50,true);
}
/***moveFeautreVerticalScrollBar()*********************************************
*** Moves the feature vertical scrollbar the way the user is pushing it     ***
*** if the bol attribute is true it will move in percent. Not in pixsels    ***
******************************************************************************/
function moveFeautreVerticalScrollBar(move,bol) {
	if (featureVerticalScrollbar.getAttribute('visibility') == "hidden") return;
	var movePercent = 147/featureScrollbarHeightHigh;
	if (bol) move *= movePercent;
	featureScrollbarY += move;
	/**
		Stopps so the scrollbar dosn't goes to far
	**/
	if (featureScrollbarY > (151-featureScrollbarHeight))
		featureScrollbarY = (151-featureScrollbarHeight);
	if (featureScrollbarY < 16)
		featureScrollbarY = 16;
	
	featureVerticalScrollbar.setAttribute('y',featureScrollbarY + "");
	
	var translate = -(147/featureScrollbarHeight) * (featureScrollbarY-16);
	var newtransform = "translate(0," + translate + ")";
	//var temp = svgdoc.getElementById('feautreWindowPropertieName');
	featureProertiesName.setAttribute('transform',newtransform);
	featureProertiesType.setAttribute('transform',newtransform);
	featureProertiesValue.setAttribute('transform',newtransform);
}
/***goToFeatureHorizontalScrollPosition()**************************************
*** This is if the user clicks on the horizontal scollbar back this will    ***
*** find out on what side of the scrollbar and go to left or right          ***
******************************************************************************/
function goToFeatureHorizontalScrollPosition(evt) {
	if (parseInt((currentClientX - featureMenuX - 26)/windowscale) > (featureScrollbarX))
		moveFeautreHorizontalScrollBar(50,true);
	else
		moveFeautreHorizontalScrollBar(-50,true);
}
/***moveFeautreHorizontalScrollBar()*******************************************
*** Moves the feature horizontal scrollbar the way the user is pushing it   ***
*** if the bol attribute is true it will move in percent. Not in pixsels    ***
******************************************************************************/
function moveFeautreHorizontalScrollBar(move,bol) {
	if (featureHorizontalScrollbar.getAttribute('visibility') == "hidden") return;
	var movePercent = 214/featureScrollbarWidthHigh;
	if (bol) move *= movePercent;
	featureScrollbarX += move;	
	/**
		Stopps so the scrollbar dosn't goes to far
	**/
	if (featureScrollbarX > (198-featureScrollbarWidth))
		featureScrollbarX = (198-featureScrollbarWidth);
	if (featureScrollbarX < 16)
		featureScrollbarX = 16;
	
	featureHorizontalScrollbar.setAttribute('x',featureScrollbarX + "");
	
	var translate = -(214/featureScrollbarWidth) * (featureScrollbarX-16);
	var newtransform = "translate(" + translate + ",0)";	
	featureProperties.setAttribute('transform',newtransform);
}