/*** history.js ***************************************************************
*** Athur:        Henning Kristiansen                                       ***
*** Program:      Map Editor                                                ***
*** Date:         2003-05-11                                                ***
*** Project:      OneMap.Submission.GUI                                     ***
***                                                                         ***
*** Description:                                                            ***
***   This file contains all of the function regared the history menu.      ***
***   It does not meen that it a stand-alone module because this is         ***
***   depended on variables from other files in this prosject. And is also  ***
***   depended on the way the SVG file is structured and has all the ID's   ***
***   that this looks for. And that noone of these ID's is being used more  ***
***   than that one time                                                    ***
***                                                                         ***
***   Every function goes throught the functions.js file except the once    ***
***   that is onclick events from the SVG                                   ***
***                                                                         ***
*** THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED        ***
*** WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF    ***
*** MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN ***
*** NO EVENT SHALL THE ONE MAP PROJECT OR ITS CONTRIBUTORS BE LIABLE FOR    ***
*** ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL  ***
*** DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS ***
*** OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)   ***
*** HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,     ***
*** STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING   ***
*** IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE      ***
*** POSSIBILITY OF SUCH DAMAGE.                                             ***
******************************************************************************/

/**
	All the variables needed within the history
**/
var history, historyMenu, historyLength = 0, historyPosition = 0, historyButtons, historyScrollbar, historyScrollbarY, historyScrollbarHeight;
var historyMenuX = 0, historyMenuY = 0, historyMenuResetX, historyMenuResetY;
var historyMenuWidth, historyMenuHeight;
var HistoryButtonColor = "#E7F5A7", HistoryButtonTextColor = "blue", HistoryButtonOverColor = "#AAC52B", HistoryButtonOverTextColor = "red";
var HistoryButtonActiveColor = "#9FB086", HistoryButtonActiveTextColor = "black", HistoryButtonRedoColor = "#959887", HistoryButtonRedoTextColor = "black";
var dragHistoryScrollbar = false, scrollHistoryBar = false, dragHistoryMenu = false;

/***initHistory()**************************************************************
*** This initiates the history menu                                         ***
******************************************************************************/
function initHistory() {
	history = svgdoc.getElementById('history');
	historyMenu = svgdoc.getElementById('historyMenu');	
	historyButtons = svgdoc.getElementById('historyButtons');	
	historyScrollbar = svgdoc.getElementById('HistoryScrollbarDrag');
	setHistoryMenu();
	createHistoryButton("Start");	
}
/***startClickHistory()********************************************************
*** cheks if it is inside the history that is been clicked                  ***
******************************************************************************/
function startClickHistory(evt) {
	var target = evt.getTarget().getAttribute('id');
	if (target == 'HistoryScrollbarDrag')
		dragHistoryScrollbar = true;
	if (target == 'HistoryMenuBackground')
		dragHistoryMenu = true;	
}
/***stopClickHistory()********************************************************
*** cheks if it is inside the history that has stopped clicked.            ***
*****************************************************************************/
function stopClickHistory(evt) {
	if (evt.getTarget().getAttribute('id') == 'HistoryScrollbarDrag')
		if (dragHistoryScrollbar) {
			dragHistoryScrollbar = false;
			return;
		}
	if (evt.getTarget().getAttribute('id') == 'HistoryMenuBackground')
		if (dragHistoryMenu) {
			dragHistoryMenu = false;
			return;
		}	
}
/***checkMouseHistory()********************************************************
*** if the menu is being dragged or the historywindow is beeing dragged     ***
*** this is the function that moves this                                    ***
******************************************************************************/
function checkMouseHistory(evt) {
	if (dragHistoryScrollbar) {
		var target = evt.getTarget().getAttribute('id');
		if ((target != 'HistoryScrollbarDrag') && (target != 'HistoryScrollbarBack'))
			dragHistoryScrollbar = false;
		else {
			if ((currentClientY - lastClientY) != 0)
				moveHistoryScrollBar((currentClientY-lastClientY),false);
		}
	}
	if (dragHistoryMenu) 
		moveHistoryMenu((currentClientX-lastClientX),(currentClientY-lastClientY));	
}
/***historyOver()**************************************************************
*** This changes the color of the button that you are having the mousover   ***
******************************************************************************/
function historyOver(evt) {
	if ((moving) || (draging)) return;	
	var p = evt.getTarget().parentNode;
	
	var backgroundbox = p.childNodes.item(0);
	backgroundbox.getStyle().setProperty('fill',HistoryButtonOverColor);;

	var buttontext = p.childNodes.item(1);
	buttontext.getStyle().setProperty('fill',HistoryButtonOverTextColor);;
}
/***historyOut()***************************************************************
*** Changes back the regular color again. But it most find out if the       ***
*** button is the active or that it is befor and after the active           ***
******************************************************************************/
function historyOut(evt) {
	if ((moving) || (draging)) return;

	var p = evt.getTarget().parentNode;
	
	var whatObj= p.childNodes.item(0);
	var rectTextObj = p.childNodes.item(1);
	
	if (parseInt(evt.getTarget().getAttribute('position')) > historyPosition) {
		whatObj.getStyle().setProperty('fill',HistoryButtonRedoColor);
		rectTextObj.getStyle().setProperty('fill',HistoryButtonRedoTextColor);
	}
	else if (parseInt(evt.getTarget().getAttribute('position')) == historyPosition) {
		whatObj.getStyle().setProperty('fill',HistoryButtonActiveColor);
		rectTextObj.getStyle().setProperty('fill',HistoryButtonActiveTextColor);		
	}
	else {
		whatObj.getStyle().setProperty('fill',HistoryButtonColor);
		rectTextObj.getStyle().setProperty('fill',HistoryButtonTextColor);
	}
}
/***moveHistory()**************************************************************
*** This moves the map to the position stored in the history. It uses       ***
*** the same technique as a regular move. But has to think of some few more ***
*** things like if the layer has been hidden and things like that           ***
******************************************************************************/
function moveHistory(item) {
	if (item == null) {
		alert("It's been a critical error that could not have happend :(");
		return;
	}
	var pointstr, points, pos;
	var kid = item.childNodes;
	
	var str = item.getAttribute('id') + ":\n";
	marked = 0;
	for (var i=0;i<kid.length;i++) {
		/**
			Finds the line
		**/
		var pol = svgdoc.getElementById(kid.item(i).getAttribute('source'));
		pointstr = new String(pol.getAttribute('points'));
		points = trim(pointstr).split(" ");
		/**
			Every points in that line that needs to be edited
		**/
		var grandKid = kid.item(i).childNodes;		
		for (var j=0;j<grandKid.length;j++) {
			pos = parseFloat(grandKid.item(j).getAttribute('sourceposition'));
			points[pos] = grandKid.item(j).getAttribute('x');
			points[pos+1] = grandKid.item(j).getAttribute('y');
			createMarked( points[pos], points[pos+1], kid.item(i).getAttribute('source'), pos, pol.getAttribute('layer'), kid.item(i).getAttribute('edited') );
		}
		
		/**
			Finds the layer of the line
		**/
		var mapLayer = svgdoc.getElementById("Map-" + pol.getAttribute('layer'));
		
		/**
			If the layer has been made uneditable it was certainly not at the time this
			was moved. So then we sets the layer back to editable again
		**/
		if (mapLayer.getAttribute('editable') == "false")	
			makeLayerEditable(mapLayer,pol.getAttribute('layer'));

		/**
			If the layer has been hidden it was certainly not at the time this
			was moved. So then we sets the layer back to visible again
		**/
		if (mapLayer.getAttribute('visibility') == "hidden") 
			makeLayerVisible(mapLayer, pol.getAttribute('layer'));
		
		var p = '';
		for(j=0;j<points.length;j++) 
			p = p + points[j] + ' ';

		pol.setAttribute('points', p);				
		pol.setAttribute('edited', kid.item(i).getAttribute('edited'));
	}
}
/***goToHistoryPosition()******************************************************
*** Finds the object in the SVG Doom tree and finds out what type of change ***
*** it has to do                                                            ***
******************************************************************************/

function goToHistoryPosition(way, i) {
	var kid = svgPoints.childNodes;
	while (kid.length>0)
		svgPoints.removeChild(kid.item(0));
	
	var historyObj = history.childNodes.item(i-1).childNodes.item(way);	
	
	what = historyObj.getAttribute('what');
	if (what == 'move')
		moveHistory(historyObj);
	if (what == 'propertychange')
		propertyChangeHistory(historyObj);
}
/***goHistory()****************************************************************
*** Goes through the history until the position that the user has clicked.  ***
*** It also finds out if it is a undo or a redo.                            ***
******************************************************************************/
function goHistory(to) {
	if (historyPosition > to) {
		for(var i=historyPosition;i>=(to+1);i--) {
			changeColorAtHistoryButton((i), HistoryButtonRedoColor, HistoryButtonRedoTextColor );
			goToHistoryPosition(0, i);
		}
	}
	if (historyPosition < to) {
		for(var i=(historyPosition+1);i<=to;i++) {
			changeColorAtHistoryButton((i-1), HistoryButtonColor, HistoryButtonTextColor );
			goToHistoryPosition(1, i);
		}
	}
	historyPosition = to;

}
/***removeHistory()************************************************************
*** removes the the history from the memory because. This happens if the    ***
*** user starts at at earlier position then what was the last.              ***
******************************************************************************/
function removeHistory() {
	var kid = historyButtons.childNodes;
	
	for(var i=(kid.length-1);i>=historyPosition;i--)
		historyButtons.removeChild(kid.item(i));	
	
	for (i=(historyPosition);i<(historyLength);i++) {
		var removeHistory = svgdoc.getElementById("History" + i);
		history.removeChild(removeHistory);
	}
	/**
		Sets the new length
	**/
	historyLength = historyPosition;
	
	/**
		Moves the scrollbar
	**/	
	var newtransform;
	if (historyLength > 4) 
		newtransform = "translate('0," + ((historyLength-4) * -20) + "')";
	else 	
		newtransform = "translate('0','0')";
	
	/**
		Sets the buttons to be at the last position
	**/
	historyButtons.setAttribute('transform',newtransform);

	if (historyLength > 4)
		moveAndResizeHistoryScrollbar();

	else
		historyScrollbar.getStyle().setProperty('visibility','hidden');
}
/***createHistoryButton(text)()************************************************
*** This creates the history button                                         ***
******************************************************************************/
function createHistoryButton(text) {
	var ButtonX, ButtonY, ButtonWidth, ButtonHeight;
	ButtonX = 0.00;
	ButtonY = (historyLength*20);
	ButtonWidth = 105;
	ButtonHeigth = 20
	var newButton = svgdoc.createElement("g");
	
	var newRect = svgdoc.createElement("rect");
	//newRect.setAttribute("id","HistoryButton" + historyLength);
	newRect.setAttribute("x",ButtonX);
	newRect.setAttribute("y",ButtonY);
	newRect.setAttribute("width",ButtonWidth);
	newRect.setAttribute("height",ButtonHeigth);
	
	var newRectStyle = newRect.getStyle();
	newRectStyle.setProperty('stroke','white');
	newRectStyle.setProperty('fill',HistoryButtonActiveColor);
	newRectStyle.setProperty('fill-opacity','0.7');
	
	newButton.appendChild(newRect);

	var newText = svgdoc.createElement("text");
	newText.appendChild(svgdoc.createTextNode (text));
	//newText.setAttribute("id","HistoryButtonText" + historyLength);
	newText.setAttribute("x",(ButtonX+15));
	newText.setAttribute("y",(ButtonY+15));
	var textStyle = newText.getStyle();
	textStyle.setProperty("fill",HistoryButtonActiveTextColor);
	newButton.appendChild(newText);

	var newRectOnTop = newRect.cloneNode(true);
	newRectOnTop.setAttribute("position",historyLength);
	//newRectOnTop.setAttribute("id","HistoryButtonOnTop" + historyLength);
	newRectOnTop.setAttribute("onclick","goHistory(" + historyLength + ")");
	newRectOnTop.setAttribute("onmousemove","checkmouse( evt,'history' )");
	newRectOnTop.setAttribute("onmousedown","startClick( evt,'history' )");
	newRectOnTop.setAttribute("onmouseup","stopClick( evt,'history' )");
	newRectOnTop.setAttribute("onmouseover","historyOver(evt)");
	newRectOnTop.setAttribute("onmouseout","historyOut(evt)");
	var newRectOnTopStyle = newRectOnTop.getStyle();
	newRectOnTopStyle.setProperty('fill-opacity',0.0);
	newButton.appendChild(newRectOnTop);
	
	historyButtons.appendChild(newButton);

	/**
		If more then 5 historybuttons the scrollbare will be visible
	**/
	if (historyLength > 4) {
		var historyButtonsTranslateY = ((historyLength-4) * -20);
		var newtransform = "translate('0," + historyButtonsTranslateY + "')";
		historyButtons.setAttribute('transform',newtransform);
		moveAndResizeHistoryScrollbar();
	}
}
/***goToHistoryScrollPosition()************************************************
*** This is if the user clicks on the scollbar back this will               ***
*** find out on what side of the scrollbar and go to left or right          ***
******************************************************************************/
function goToHistoryScrollPosition(evt) {
	if (evt.getClientY() > (historyScrollbarY+historyMenuY))
		moveHistoryScrollBar(50,true);
	else
		moveHistoryScrollBar(-50,true);
}
/***moveHistoryMenu()**********************************************************
*** A function to move the menu. The parameter shows how much it will move  ***
*** It also stores what the x and y value for the menu at all time. And if  ***
*** the windowscale is wider then the 800/500 scale it will add to the X so ***
*** much that it would look like it goes up to the right corner.            ***
***                                                                         ***
*** View the documentation for more information about this                  ***
******************************************************************************/
function moveHistoryMenu(moveX, moveY) {
	historyMenuX += moveX;
	historyMenuY += moveY;

	if (windowscaleway) {
		var newWidth = (130 * windowscale);
		var newXAdd = (130 * windowscaleWidth);
		newXAdd -= newWidth;
	}
	else
		var newXAdd = 0;

	historyMenu.setAttribute('x',historyMenuX+newXAdd + "");
	historyMenu.setAttribute('y',historyMenuY + "");
}
/***setHistoryMenu()***********************************************************
*** This finds out what the x and y value is from the start and stores that ***
*** in case it will ever be reset. After that it will scale to fit the      ***
*** current view that the SVG window is in                                  ***
******************************************************************************/
function setHistoryMenu() {
	historyMenuResetX = parseInt(historyMenu.getAttribute('x'));
	historyMenuResetY = parseInt(historyMenu.getAttribute('y'));	
	historyMenuX = (historyMenuResetX * ratioWidth);
	historyMenuY = (historyMenuResetY * ratioHeight);		
	
	scaleHistoryMenu(false);
}
/***scaleHistoryMenu()*********************************************************
*** This scales the menu so it will be put at the right place with the      ***
*** right height and width                                                  ***
******************************************************************************/
function scaleHistoryMenu(move) {
	
	var newWidth = (130 * windowscale);
	var newHeight = (130 * windowscale);
	
	historyMenu.setAttribute('width', newWidth + "");
	historyMenu.setAttribute('height', newHeight + "");
	

	if (move) 
		moveHistoryMenu(((historyMenuX*ratioWidth) - historyMenuX), ((historyMenuY*ratioHeight) - historyMenuY));
}
/***resetHistoryMenu()*********************************************************
*** reset the menu to it's orignial view                                    ***
******************************************************************************/
function resetHistoryMenu() {
	historyMenu.setAttribute('x',(historyMenuResetX * ratioWidth) + "");
	historyMenu.setAttribute('y',(historyMenuResetY * ratioHeight) + "");
}
/***moveHistoryScrollBar()*****************************************************
*** Moves the historymenus scrollbar the way the user is pushing it         ***
*** if the bol attribute is true it will move in percent. Not in pixsels    ***
******************************************************************************/
function moveHistoryScrollBar(move,bol) {
	if (historyLength < 5) return;
	var movePercent = 100/((historyLength+1)*20);
	if (bol) move *= movePercent;
	historyScrollbarY += move;
	
	if (historyScrollbarY > (107-historyScrollbarHeight))
		historyScrollbarY = (107-historyScrollbarHeight);
	if (historyScrollbarY < 33)
		historyScrollbarY = 33;
	
	historyScrollbar.setAttribute('y',historyScrollbarY + "");
	
	var historyButtonsTranslateY = -(100/historyScrollbarHeight) * (historyScrollbarY-33);
	var newtransform = "translate('0," + historyButtonsTranslateY + "')";	
	historyButtons.setAttribute('transform',newtransform);
}
/***moveAndResizeHistoryScrollbar()********************************************
*** Moves the historymenu to the last posistion and resizes the scrollbar   ***
*** to the new size                                                         ***
******************************************************************************/
function moveAndResizeHistoryScrollbar() {
	historyScrollbarHeight = 74 * (100/((historyLength+1)*20));
	historyScrollbarY = 33 + (74 - historyScrollbarHeight);
	historyScrollbar.getStyle().setProperty('visibility','visible');
	historyScrollbar.setAttribute('y',historyScrollbarY + "");
	historyScrollbar.setAttribute('height',historyScrollbarHeight + "");
}
/***changeColorAtHistoryButton()***********************************************
*** Changes the color at the historybutton                                  ***
******************************************************************************/
function changeColorAtHistoryButton(pos, BackColor, TextColor) {
	var whatObj= historyButtons.childNodes.item(pos).childNodes.item(0); 
	var textObj = historyButtons.childNodes.item(pos).childNodes.item(1);
	
	whatObj.getStyle().setProperty('fill',BackColor);
	textObj.getStyle().setProperty('fill',TextColor);

}
/***addPropertyChangeToHistory()***********************************************
*** Adds propertychange to the history. Allmost the same as adding move     ***
*** to the history                                                          ***
***                                                                         ***
*** It adds both the old value and new value and keeps tracks of whats been ***
*** edited or not                                                           ***
******************************************************************************/
function addPropertyChangeToHistory(newData,oldData,property,feature,what) {
	var newHistory = svgdoc.createElement("g");
	var undo = svgdoc.createElement("g");
	var redo = svgdoc.createElement("g");

	historyLength++;
	historyPosition++;

	if(historyPosition < historyLength)
		removeHistory();

	undo.setAttribute("what","propertychange");
	redo.setAttribute("what","propertychange");
	
	var propertyobject = svgdoc.getElementById(property.getAttribute('propertyid'));
	propertyobject.setAttribute(what,newData);
	
	var edited = propertyobject.getAttribute('edited');
	if (edited == "no")
		propertyobject.setAttribute("edited","yes");
	
	undo.setAttribute("edited", edited);
	redo.setAttribute("edited", "yes");
	
	undo.setAttribute("propertyid",property.getAttribute('propertyid'));
	redo.setAttribute("propertyid",property.getAttribute('propertyid'));
	
	undo.setAttribute("where",what);
	redo.setAttribute("where",what);
	
	undo.setAttribute("data",oldData);
	redo.setAttribute("data",newData);

	undo.setAttribute("layer",feature.getAttribute('layer'));
	redo.setAttribute("layer",feature.getAttribute('layer'));
	
	createHistoryButton("propertychange");
	changeColorAtHistoryButton(historyLength-1, HistoryButtonColor, HistoryButtonTextColor );
	
	newHistory.appendChild(undo);
	newHistory.appendChild(redo);
	
	//alert(historyLength);
	newHistory.setAttribute("id","History" + (historyLength));

	history.appendChild(newHistory);
}
/***propertyChangeHistory()****************************************************
*** changes the value back to what it has been stored in the history        ***
******************************************************************************/
function propertyChangeHistory(item) {
	var property = svgdoc.getElementById(item.getAttribute('propertyid'));
	property.setAttribute('edited',item.getAttribute('edited'));
	property.setAttribute(item.getAttribute('where'),item.getAttribute('data'));


	var mapLayer = svgdoc.getElementById("Map-" + item.getAttribute('layer'));
	if (mapLayer.getAttribute('editable') == "false")	
		makeLayerEditable(mapLayer,item.getAttribute('layer'));

	if (mapLayer.getAttribute('visibility') == "hidden") 
		makeLayerVisible(mapLayer, item.getAttribute('layer'));

	if (featureMenuShow.getAttribute('visibility') == "visible")
		setProperties();		
}
/***addMoveToHistory()*********************************************************
*** Adds the move to the history. This stores both the before and after     ***
*** values                                                                  ***
******************************************************************************/
function addMoveToHistory() {
	var newHistory = svgdoc.createElement("g");
	var undo = svgdoc.createElement("g");
	var redo = svgdoc.createElement("g");
	var pol = svgPoints.childNodes;

	historyLength++;
	historyPosition++;

	if(historyPosition < historyLength)
		removeHistory();
	
	undo.setAttribute("what","move");
	redo.setAttribute("what","move");
	
	/**
		Goes trough every point that has been selected and gets the value from it
	**/
		
	for(var i=0;i<pol.length;i++) {
		var source = pol.item(i).getAttribute('source');
		var edited = pol.item(i).getAttribute('edited');
		/**
			Keeps tracks of the editing part
		**/
		if (edited == "no") {
			var temp = svgdoc.getElementById(source);
			pol.item(i).setAttribute("edited","yes");
			temp.setAttribute("edited","yes");
		}
		var kid = pol.item(i).childNodes;
		var undoKid = svgdoc.createElement("g");
		var redoKid = svgdoc.createElement("g");
		undoKid.setAttribute("source", source);
		undoKid.setAttribute("edited", edited);
		redoKid.setAttribute("source", source);
		redoKid.setAttribute("edited", "yes");

		for(var j=0;j<kid.length;j++) {
			var undoGrandKid = svgdoc.createElement("g");
			undoGrandKid.setAttribute("sourceposition", kid.item(j).getAttribute('sourceposition'));
			undoGrandKid.setAttribute("x", (parseFloat(kid.item(j).getAttribute("cx")) - (x - startMoveX)));
			undoGrandKid.setAttribute("y", (parseFloat(kid.item(j).getAttribute("cy")) - (y - startMoveY)));
			undoKid.appendChild(undoGrandKid);

			var redoGrandKid = svgdoc.createElement("g");
			redoGrandKid.setAttribute("sourceposition", kid.item(j).getAttribute('sourceposition'));
			redoGrandKid.setAttribute("x", kid.item(j).getAttribute("cx"));
			redoGrandKid.setAttribute("y", kid.item(j).getAttribute("cy"));
			redoKid.appendChild(redoGrandKid);
		}
		undo.appendChild(undoKid);
		redo.appendChild(redoKid);
	}
	/**
		Creates the button
	**/
	createHistoryButton("move");
	changeColorAtHistoryButton(historyLength-1, HistoryButtonColor, HistoryButtonTextColor );
	
	newHistory.appendChild(undo);
	newHistory.appendChild(redo);
	
	newHistory.setAttribute("id","History" + (historyLength));

	history.appendChild(newHistory);
}