/*** navigator.js *************************************************************
*** Athur:        Henning Kristiansen                                       ***
*** Program:      Map Editor                                                ***
*** Date:         2003-05-11                                                ***
*** Project:      OneMap.Submission.GUI                                     ***
***                                                                         ***
*** Description:                                                            ***
***   This file contains all of the function regared the navigator menu.    ***
***   It does not meen that it a stand-alone module because this is         ***
***   depended on variables from other files in this prosject. And is also  ***
***   depended on the way the SVG file is structured and has all the ID's   ***
***   that this looks for. And that noone of these ID's is being used more  ***
***   than that one time                                                    ***
***                                                                         ***
***   Every function goes throught the functions.js file except the once    ***
***   that is onclick events from the SVG                                   ***
***                                                                         ***
*** THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED        ***
*** WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF    ***
*** MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN ***
*** NO EVENT SHALL THE ONE MAP PROJECT OR ITS CONTRIBUTORS BE LIABLE FOR    ***
*** ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL  ***
*** DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS ***
*** OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)   ***
*** HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,     ***
*** STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING   ***
*** IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE      ***
*** POSSIBILITY OF SUCH DAMAGE.                                             ***
******************************************************************************/

/**
	All the variables needed within the navigator
**/
var theNavigator, navigatorView, navigatorOnTop;
var navigatorX,navigatorY = 0,navigatorWidth,navigatorHeight;
var navigatorMenu, navigatorMenuX, navigatorMenuY, navigatorMenuResetX, navigatorMenuResetY;
var dragNavigatorView = false, dragNavigatorMenu = false;
var windowscale, windowscaleway, windowscaleWidth, windowscaleHeight;


/***initNavigator()************************************************************
*** This initiates the navigater                                            ***
******************************************************************************/
function initNavigator() {
	theNavigator = svgdoc.getElementById('Navigator');
	navigatorView = svgdoc.getElementById('NavigatorView');
	navigatorMenu = svgdoc.getElementById('NavigatorMenu');
		
	var navmap = svgdoc.getElementById('navigatorMap');
	navigatorRatio = parseFloat(navmap.getAttribute('width'))/parseFloat(navmap.getAttribute('height'));
	
	setNavigatorMenu();
}
/***moveNavigatorMenu()********************************************************
*** A function to move the menu. The parameter shows how much it will move  ***
*** It also stores what the x and y value for the menu at all time. And if  ***
*** the windowscale is wider then the 800/500 scale it will add to the X so ***
*** much that it would look like it goes up to the right corner.            ***
***                                                                         ***
*** View the documentation for more information about this                  ***
******************************************************************************/
function moveNavigatorMenu(moveX, moveY) {
	navigatorMenuX += moveX;
	navigatorMenuY += moveY;

	if (windowscaleway) {
		var newWidth = (130 * windowscale);
		var newXAdd = (130 * windowscaleWidth);
		newXAdd -= newWidth;
	}
	else
		var newXAdd = 0;

	navigatorMenu.setAttribute('x',navigatorMenuX+newXAdd + "");
	navigatorMenu.setAttribute('y',navigatorMenuY + "");
}
/***setNavigatorMenu()*********************************************************
*** This finds out what the x and y value is from the start and stores that ***
*** in case it will ever be reset. After that it will scale to fit the      ***
*** current view that the SVG window is in                                  ***
******************************************************************************/
function setNavigatorMenu() {
	navigatorMenuResetX = parseInt(navigatorMenu.getAttribute('x'));
	navigatorMenuResetY = parseInt(navigatorMenu.getAttribute('y'));	
			
	navigatorMenuX = (navigatorMenuResetX * ratioWidth);
	navigatorMenuY = (navigatorMenuResetY * ratioHeight);
	scaleNavigatorMenu(false);
}
/***resetNavigatorMenu()*******************************************************
*** reset the menu to it's orignial view                                    ***
******************************************************************************/
function resetNavigatorMenu() {
	navigatorMenuX += navigatorMenuResetX;
	navigatorMenuY += navigatorMenuResetY;

	if (windowscaleway) {
		var newWidth = (130 * windowscale);
		var newXAdd = (130 * windowscaleWidth);
		newXAdd -= newWidth;
	}
	else
		var newXAdd = 0;

	navigatorMenu.setAttribute('x',(navigatorMenuX * ratioWidth)+newXAdd + "");
	navigatorMenu.setAttribute('y',(navigatorMenuY * ratioHeight) + "");
}
/***scaleNavigatorMenu()*******************************************************
*** This scales the menu so it will be put at the right place with the      ***
*** right height and width                                                  ***
******************************************************************************/
function scaleNavigatorMenu(move) {		
	var newWidth = (130 * windowscale);
	var newHeight = (130 * windowscale);

	navigatorMenu.setAttribute('width', newWidth + "");
	navigatorMenu.setAttribute('height', newHeight + "");
	
	if (move) 
		moveNavigatorMenu(((navigatorMenuX*ratioWidth) - navigatorMenuX), ((navigatorMenuY*ratioHeight) - navigatorMenuY));
}

/***scaleNavigatorMenu()*******************************************************
*** This sets the navigater window to fit exactly in to the nevaigator view ***
*** regardless of how it looks                                              ***
******************************************************************************/
function setNavigatorWindow() {
	/**
		The navigator window have to fit inside a rectanglar that are 110 wide 
		and 86 high. To use as much space we as we can of this we have to 
		calculate the navigator window to either be as wide as the coverall or 
		as tall as the coverall. Which ever fit the best. The side that does 
		not fit exactly will be centered in the middle
	**/
	var coverallRatio = coverallWidth/coverallHeight;
	if (navigatorRatio > coverallRatio) {
		navigatorWidth = 86*coverallRatio;
		navigatorHeight = 86;
		navigatorX = (110-navigatorWidth)/2;
		navigatorY = 0;
	}
	else {
		navigatorWidth = 110;
		navigatorHeight = 110/coverallRatio;
		navigatorX = 0;
		navigatorY = (86-navigatorHeight)/2;
	}
	
	/**
		Sets the values that has been calulated
	**/
	theNavigator.setAttribute('width', navigatorWidth + "");
	theNavigator.setAttribute('height', navigatorHeight + "");
	theNavigator.setAttribute('x', navigatorX + "");
	theNavigator.setAttribute('y', navigatorY + "");

	/**
		Calls the function that set's what's it seeing right now
	**/
	setNavigatorView();
	
	/**
		This puts the navigator map at the right place
	**/
	var navmap = svgdoc.getElementById("navigatorMap");
	navmap.setAttribute('x', navigatorX + "");
	navmap.setAttribute('y', navigatorY + "");
	navmap.setAttribute('width', navigatorWidth + "");
	navmap.setAttribute('height', navigatorHeight + "");
}

/***setNavigatorView()*********************************************************
*** If you see the first version of how this works you will see that is     ***
*** much more complex then what I have come up with now. Since the          ***
*** coordinates in this navigator are exactly the same as the map then this ***
*** is allreaddy calculatet. The only thing needed is to create a           ***
*** rectangular with the same x, y, width and height as the viewX, viewY,   ***
*** viewWidth and viewHeight. And it works like a charm.                    ***
***                                                                         ***
*** The reason why this was not done before is that at first I did not have ***
*** the coordinate system exactly like the map here in the first. And then  ***
*** I had to calculate this in a rather 'stupid' way then what it does now  ***
******************************************************************************/
function setNavigatorView() {
	navigatorView.setAttribute('width', viewWidth + "");
	navigatorView.setAttribute('height', viewHeight + "");
	navigatorView.setAttribute('x', viewX + "");
	navigatorView.setAttribute('y', viewY + "");
}

/***moveDragNavigatorView()****************************************************
*** Moves the view of the map while draing the navigator windows. This will ***
*** not reset the navigator view in here. But it will reset the orignal     ***
*** coordinates for the map whitch then will automatilcy move the navigator ***
*** view                                                                    ***
******************************************************************************/
function moveDragNavigatorView(moveX, moveY) {
	/**
		The ratio calculates how much the orginal viweWidth is compared the
		the width inside the navigator.
	**/
	var ratio = viewWidth/(navigatorWidth*(viewWidth/coverallWidth));
	var moveOrgX = ratio * moveX;
	var moveOrgY = ratio * moveY;

	resetOrginalCoords((viewX+moveOrgX), (viewY+moveOrgY), viewWidth, viewHeight, true);
}
/***scaleNavigatorMenu()*******************************************************
*** This sets the windowscale that will be used to scale objects and        ***
*** x and y inside menu items                                               ***
******************************************************************************/
function setWindowScale() {
	windowscaleWidth = window.innerWidth/800;
	windowscaleHeight = window.innerHeight/500;
	if ((window.innerWidth/window.innerHeight) > 1.6) {
		windowscaleway = true;
		windowscale = windowscaleHeight;
	}
	else {
		windowscaleway = false;
		windowscale = windowscaleWidth;
	}
}
/***startClickNavigator()******************************************************
*** cheks if it is inside the navigator that is been clicked                ***
******************************************************************************/
function startClickNavigator(evt) {
	var target = evt.getTarget().getAttribute('id');
	if (target == 'NavigatorView')
		dragNavigatorView = true;
	if (target == 'NavigatorBackground')
		dragNavigatorMenu = true;	
}
/***stopClickNavigator()*******************************************************
*** cheks if it is inside the navigator that has stopped clicked.           ***
******************************************************************************/
function stopClickNavigator(evt) {
	if (evt.getTarget().getAttribute('id') == 'NavigatorView')
		if (dragNavigatorView) {
			dragNavigatorView = false;
			return;
		}
	if (evt.getTarget().getAttribute('id') == 'NavigatorBackground')
		if (dragNavigatorMenu) {
			dragNavigatorMenu = false;
			return;
		}
}
/***startClickNavigator()******************************************************
*** if the menu is being dragged or the navigatorview is beeing dragged     ***
*** this is the function that moves this                                    ***
******************************************************************************/
function checkMouseNavigator(evt) {	
	if (dragNavigatorMenu) 
		moveNavigatorMenu((currentClientX-lastClientX),(currentClientY-lastClientY));

	if (dragNavigatorView) {
		var target = evt.getTarget().getAttribute('id');
		if ((target == 'NavigatorView') || (target == 'NavigatorOnTop')) {
			var nowX = parseInt(currentClientX/windowscale);
			var lastX = parseInt(lastClientX/windowscale);

			var nowY = parseInt(currentClientY/windowscale);
			var lastY = parseInt(lastClientY/windowscale);

			moveDragNavigatorView((nowX-lastX),(nowY-lastY));
		}
		else
			dragNavigatorView = false;
	}
}
