/*** save.js ******************************************************************
*** Athur:        Henning Kristiansen                                       ***
*** Program:      Map Editor                                                ***
*** Date:         2003-05-11                                                ***
*** Project:      OneMap.Submission.GUI                                     ***
***                                                                         ***
*** Description:                                                            ***
***   This file contains all of the function regared the save menu.         ***
***                                                                         ***
*** THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED        ***
*** WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF    ***
*** MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN ***
*** NO EVENT SHALL THE ONE MAP PROJECT OR ITS CONTRIBUTORS BE LIABLE FOR    ***
*** ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL  ***
*** DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS ***
*** OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)   ***
*** HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,     ***
*** STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING   ***
*** IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE      ***
*** POSSIBILITY OF SUCH DAMAGE.                                             ***
******************************************************************************/
var lastFeature = "";
var svgdoc;

/***save()*********************************************************************
*** Gets the information from the SVG DOM tree and order it after the       ***
*** position attribute                                                      ***
***                                                                         ***
*** For more information about this look in the documenation                ***
******************************************************************************/
function save( ) {
	lastFeature = "";
	svgdoc = document.MapEditor.getSVGDocument();	
	var history = svgdoc.getElementById('history');
	if (history.childNodes.length == 0) {
		alert("You didn't do anything!");
		return false;
	}

	
	var feature;
	var map = svgdoc.getElementById('map');
	var SVGOut = map.getAttribute("filename") + "\n";
	var maps = map.childNodes;
	for(var i=0;i<maps.length;i++) {
		var line = maps.item(i).childNodes;
		for(var j=0;j<line.length;j++) {
			if (line.item(j).nodeName == "g") {
				var polygon = line.item(j).childNodes;
				for(var k=0;k<polygon.length;k++) {
					feature = polygon.item(k).getAttribute("feature");
					SVGOut += writeFeature(feature);
					if (polygon.item(k).getAttribute("edited") == "yes") SVGOut += "map\t" + polygon.item(k).getAttribute("position") + "\t" + polygon.item(k).getAttribute("coordtype") + "\t" + polygon.item(k).getAttribute("primitive") + "\t" + polygon.item(k).getAttribute("points") + "\n";
				}
				
			}
			else {
				feature = line.item(j).getAttribute("feature");
				SVGOut += writeFeature(feature);
				if (line.item(j).getAttribute("edited") == "yes") SVGOut += "map\t" + line.item(j).getAttribute("position") + "\t" + line.item(j).getAttribute("coordtype") + "\t" + line.item(j).getAttribute("primitive") + "\t" + line.item(j).getAttribute("points") + "\n";
			}
		}
	}
	SVGOut += writeFeature("end");

	document.forms[0].SVGSave.value = SVGOut;
	
	alert("This is what that will be sent to the JSP server:\n\n" + SVGOut);
	
	return true;
}
/***writeFeature()*************************************************************
*** Writes the feature info if hasnit been written before                   ***
***                                                                         ***
*** For more information about this look in the documenation                ***
******************************************************************************/

function writeFeature(feature) {
	if ((feature == lastFeature) || (lastFeature == "")) {
		lastFeature = feature;
		return "";
	}
	var f = svgdoc.getElementById(lastFeature);
	
	var returnString = "";
	var kid = f.childNodes;
	for (var i=0;i<kid.length;i++)
		if (kid.item(i).getAttribute("edited") == "yes") returnString += "feature\t" + kid.item(i).getAttribute("position") + "\t" + kid.item(i).getAttribute("name") + "\t" + kid.item(i).getAttribute("type") + "\t" + kid.item(i).getAttribute("value") + "\n";
		
	
	lastFeature = feature;
	return returnString;
}